diff --git a/gcc/common.opt b/gcc/common.opt
index 4368910..041cfd7 100644
--- a/gcc/common.opt
+++ b/gcc/common.opt
@@ -1597,6 +1597,10 @@ fkeep-gc-roots-live
 Common Undocumented Report Var(flag_keep_gc_roots_live) Optimization
 ; Always keep a pointer to a live memory block
 
+flocation-ranges
+Common Report Var(flag_location_ranges) Init(1)
+Enable range tracking when recording source locations.
+
 floop-parallelize-all
 Common Report Var(flag_loop_parallelize_all) Optimization
 Mark all loops as parallel.
diff --git a/gcc/doc/invoke.texi b/gcc/doc/invoke.texi
index 96a9516..2faac62 100644
--- a/gcc/doc/invoke.texi
+++ b/gcc/doc/invoke.texi
@@ -574,7 +574,7 @@ Objective-C and Objective-C++ Dialects}.
 -fdebug-cpp  -fdirectives-only  -fdollars-in-identifiers  @gol
 -fexec-charset=@var{charset}  -fextended-identifiers  @gol
 -finput-charset=@var{charset}  -fmacro-prefix-map=@var{old}=@var{new}  @gol
--fmax-include-depth=@var{depth} @gol
+-fmax-include-depth=@var{depth} -flocation-ranges @gol
 -fno-canonical-system-headers  -fpch-deps  -fpch-preprocess  @gol
 -fpreprocessed  -ftabstop=@var{width}  -ftrack-macro-expansion  @gol
 -fwide-exec-charset=@var{charset}  -fworking-directory @gol
@@ -14151,6 +14151,13 @@ This option may be useful in conjunction with the @option{-B} or
 perform additional processing of the program source between
 normal preprocessing and compilation.
 
+@item -flocation-ranges
+@opindex flocation-ranges
+Enable range tracking when recording source locations.
+By default, GCC enables range tracking when recording source locations.
+If disable range tracking by -fno-location-ranges, more location space
+will be saved for column tracking.
+
 @end table
 
 @node Assembler Options
diff --git a/gcc/toplev.c b/gcc/toplev.c
index 4c8be50..5d035de 100644
--- a/gcc/toplev.c
+++ b/gcc/toplev.c
@@ -1854,6 +1854,9 @@ process_options (void)
     hash_table_sanitize_eq_limit
       = param_hash_table_verification_limit;
 
+  if (!flag_location_ranges)
+    line_table->default_range_bits = 0;
+
   /* Please don't change global_options after this point, those changes won't
      be reflected in optimization_{default,current}_node.  */
 }
